# postban.sh
# Temporary Ban SpamOnly Ip
# -------------------------
#
# This script create a table for postfix that ban IPs that made high spam results only
#
# 1) Put this script anywhere and set your parameters
# 2) Put in crontab a line like this to run every 1 minute :
# * * * * * /batch/postban.sh 
# 3) Modify your main.cf in postfix at this line like here and then postfix reload :
# smtpd_client_restrictions = (OTHER YOUR PARAMETERS) check_client_access hash:/etc/postfix/postban_access



# Start time
start=`date +%s`

# Parameters
ROOTPWD=<YOURMYSQLROOTPWD>
VSCORESPAM=6       # Search for IP that have more than VSCORESPAM score
VMINSPAM=4320      # In the last VMINSPAM minutes
VSCOREHAM=4        # But exclude if the ip sent message that have less than VSCOREHAM
VMINHAM=28800      # In the last VMINHAM minutes
# In the default config it block ip that sent email that have more than score 6 
# for 4320 mins (3 days) from last event, but exclude if this ip have a mail sent
# in the last 20 days (28800 mins) that have a score less than 4
VLOGFILE=/batch/postban.log                                # Logfile position
VACCFILE=/etc/postfix/postban_access                       # Access file position
RJMESSAGE="Server bloccato causa spam"                     # Reject Message
CMDPOSTMAP="/usr/sbin/postmap /etc/postfix/postban_access" # Postmap command

# Date & Time
NOW=$(date +"%m-%d-%Y %r")

# Touching log file
touch $VLOGFILE

# Exit if no VSCORESPAM in the last minute
S0="SELECT count(clientip) \
 FROM mailscanner.maillog \
 WHERE timestamp > DATE_SUB(now(), INTERVAL 1 MINUTE) \
 AND spamwhitelisted = 0 \
 AND clientip NOT LIKE '10.%' \
 AND clientip NOT LIKE '192.168.%' \
 AND sascore > $VSCORESPAM \
 ;"
res0=$(mysql -N -u root -p$ROOTPWD -se "$S0")
##echo $res0
if [[ $res0 -gt 0 ]] ; then
 echo $NOW " Found" $res0 "spam ip in the last minute, rebuilding postban table" >> $VLOGFILE
else
 echo $NOW " No spam found in the last minute, skipping" >> $VLOGFILE
 exit
fi 


# Main selection query, table mailscanner
S1="SELECT clientip \
 FROM mailscanner.maillog \
 WHERE timestamp > DATE_SUB(now(), INTERVAL $VMINSPAM MINUTE) \
 AND spamwhitelisted = 0 \
 AND clientip NOT LIKE '10.%' \
 AND clientip NOT LIKE '192.168.%' \
 AND sascore > $VSCORESPAM \
 GROUP BY clientip;"

echo "# Generated by postban.sh " $start > $VACCFILE
f=0;ff=0
res1=($(mysql -N -u root -p${ROOTPWD} -e "${S1}"))
cnt=${#res1[@]}
for (( i=0 ; i<${cnt} ; i++  ))
do
 #echo "Found line " $i " " ${res1[i]}
 CLIP=${res1[i]}
 S2="SELECT clientip \
  FROM mailscanner.maillog \
  WHERE timestamp > DATE_SUB(now(), INTERVAL $VMINHAM MINUTE) \
  AND clientip = '${res1[i]}' \
  AND sascore < $VSCOREHAM \
  GROUP BY clientip;" 
 #echo $S2 
 res2=$(mysql -N -u root -p$ROOTPWD -se "$S2")
 #echo $res2
 let "f++"
 if [[ $res2 == "" ]] ; then
  let "ff++"
  #echo "Not found ham so write spam ip " $CLIP
  echo $CLIP " REJECT " $RJMESSAGE >> $VACCFILE
 fi

done

# Postmap (doing postmap is enough to get new ip table without refreshing)
eval $CMDPOSTMAP

# Logging
end=`date +%s`
runtime=$((end-start))
echo $NOW " " $f "spam ip," $ff "with no ham in the past written in reject table, time elapsed:" $runtime "sec." >> $VLOGFILE

# Truncating logfile
tail -n 500 $VLOGFILE > $VLOGFILE.tmp
mv $VLOGFILE.tmp $VLOGFILE


